<?php

include_once (MYSQL);
include_once (dirname(__FILE__)."/localization.php");
include_once (dirname(__FILE__)."/users.php");
include_once (dirname(__FILE__)."/clients.php");
include_once (dirname(__FILE__)."/ban.php");

class auth {
	
    function auth () {
		$this->DB = new DB;
		$this->DB->connect();
		$this->LOCALIZE = new localization;
		$this->USERS = new users;
		$this->CLIENTS = new clients;
		$this->BAN = new ban;
    }
	
	function userLogin($email, $pass, $lang) {
		
		$lang = $this->LOCALIZE->checkLanguage($lang);
		
		$long = sprintf("%u", ip2long($_SERVER['REMOTE_ADDR']));
		$getdata = $this->DB->query("SELECT ends_at FROM ban_ip 
		                             WHERE $long >= ip_from AND $long <= ip_to AND (ends_at >= UNIX_TIMESTAMP() OR ends_at = 0);");
		$section = $this->DB->fetch_array($getdata);
		$rows = $this->DB->get_num_rows();
		if ($rows > 0) {
			$date = $section['ends_at'] != 0 ? date("d.m.Y", $section['ends_at']) : $this->LOCALIZE->getPhrase('never', $lang); 
			return array('valid' => false, 
						 'error' => $this->LOCALIZE->getPhrase('login_error_ip_ban', $lang).' '.$date,
						 'title' => $this->LOCALIZE->getPhrase('login_error_title', $lang));
		}
		
		$getdata = $this->DB->query("SELECT ends_at FROM ban_emails WHERE email = '$email';");
		$section = $this->DB->fetch_array($getdata);
		$rows = $this->DB->get_num_rows();
		if ($rows > 0) {
			$date = $section['ends_at'] != 0 ? date("d.m.Y", $section['ends_at']) : $this->LOCALIZE->getPhrase('never', $lang); 
			return array('valid' => false, 
						 'error' => $this->LOCALIZE->getPhrase('login_error_email_ban', $lang).' '.$date,
						 'title' => $this->LOCALIZE->getPhrase('login_error_title', $lang));
		}
		
		if ($this->BAN->banCountry()) {
			return array('valid' => false, 
						 'error' => $this->LOCALIZE->getPhrase('login_error_country_ban', $lang),
						 'title' => $this->LOCALIZE->getPhrase('login_error_title', $lang));
		}
		
		/*$getdata = $this->DB->query("SELECT SUM(user_count) as uc FROM rooms;");
		$section = $this->DB->fetch_array($getdata);
		$max = $this->CLIENTS->getMaxUsers();
		if ($max > 0 && $section['uc'] >= $max) {
			return array('valid' => false, 
						 'error' => $this->LOCALIZE->getPhrase('login_error_chat_max_users', $lang),
						 'title' => $this->LOCALIZE->getPhrase('login_error_title', $lang));
		}*/
		
		/*$getdata = $this->DB->query("SELECT user_count, max_users FROM rooms WHERE id = '$room_id';");
		$section = $this->DB->fetch_array($getdata);
		if ($section['user_count'] >= $section['max_users']) {
			return array('valid' => false, 
						 'error' => $this->LOCALIZE->getPhrase('login_error_room_max_users', $lang),
						 'title' => $this->LOCALIZE->getPhrase('login_error_title', $lang));
		}*/
					
		$getdata = $this->DB->query("SELECT * FROM users WHERE email = '$email' AND password = MD5('$pass') LIMIT 1;");
		$rows = $this->DB->get_num_rows($getdata);	
		$section = $this->DB->fetch_array($getdata);	
		
		$id = $section['id'];
		
		$utype = $section['utype'];
		if ($utype == "") $utype = "user"; 
		
		$active = $section['active'];
		$status = $section['status'];
		
		if ($id == "") {
			return array('valid' => false, 
						 'error' => $this->LOCALIZE->getPhrase('login_error_name_or_password', $lang),
						 'title' => $this->LOCALIZE->getPhrase('login_error_title', $lang));
		}
		
		if ($active == 0) {
			return array('valid' => false, 
						 'error' => $this->LOCALIZE->getPhrase('login_error_account_ban', $lang),
						 'title' => $this->LOCALIZE->getPhrase('login_error_title', $lang));
		}
		
		$name = $section['name'];
		$data = unserialize($section['data']);		
		$gender = $data['gender'];
		
		if ($utype == "demo") $utype = "user";
		
		if ($section['avatar'] != "") {
			$avatar = $section['avatar'];
		} else {
			switch ($gender) {
				case "m":
					$avatar = "upload/m_avatar.jpg";
					break;
				case "f":
					$avatar = "upload/f_avatar.jpg";
					break;
			}
		}
		
		$translation = 0;
		$getdata = $this->DB->query("SELECT id FROM rooms WHERE owner = '$id' LIMIT 1;");
		$section = $this->DB->fetch_array($getdata);
		$rows = $this->DB->get_num_rows();
		if ($rows > 0) {
			$translation = $section['id']; 
		}
		
		return array('id' => $id, 
		             'utype' => $utype,
		             'name' => $name, 			
					 'gender' => $gender, 
					 'avatar' => $avatar, 
					 'ip' => $_SERVER['REMOTE_ADDR'], 
					 'friends' => $this->USERS->getFriends($id, true), 
					 'blocks' => $this->USERS->getBlocks($id, true), 
					 'time' => time(), 
					 'translation' => $translation,
					 'valid' => true);
		
	}
	
	function guestLogin($nick, $gender, $lang) {
		
		$lang = $this->LOCALIZE->checkLanguage($lang);
		
		$long = sprintf("%u", ip2long($_SERVER['REMOTE_ADDR']));
		$getdata = $this->DB->query("SELECT ends_at FROM ban_ip 
		                             WHERE $long >= ip_from AND $long <= ip_to AND (ends_at >= UNIX_TIMESTAMP() OR ends_at = 0);");
		$section = $this->DB->fetch_array($getdata);
		$rows = $this->DB->get_num_rows();
		if ($rows > 0) {
			$date = $section['ends_at'] != 0 ? date("d.m.Y", $section['ends_at']) : $this->LOCALIZE->getPhrase('never', $lang); 
			return array('valid' => false, 
						 'error' => $this->LOCALIZE->getPhrase('login_error_ip_ban', $lang).' '.$date,
						 'title' => $this->LOCALIZE->getPhrase('login_error_title', $lang));
		}
		
		if ($this->BAN->banCountry()) {
			return array('valid' => false, 
						 'error' => $this->LOCALIZE->getPhrase('login_error_country_ban', $lang),
						 'title' => $this->LOCALIZE->getPhrase('login_error_title', $lang));
		}
		
		$getdata = $this->DB->query("SELECT id FROM users WHERE name = '$nick' LIMIT 1");
		$rows = $this->DB->get_num_rows($getdata);
		if ($rows > 0) {
			return array('valid' => false, 
						 'error' => $this->LOCALIZE->getPhrase('r_name_exists_guest', $lang),
						 'title' => $this->LOCALIZE->getPhrase('error', $lang));
		}
		
		/*$getdata = $this->DB->query("SELECT SUM(user_count) as uc FROM rooms;");
		$section = $this->DB->fetch_array($getdata);
		$max = $this->CLIENTS->getMaxUsers();
		if ($max > 0 && $section['uc'] >= $max) {
			return array('valid' => false, 
						 'error' => $this->LOCALIZE->getPhrase('login_error_chat_max_users', $lang),
						 'title' => $this->LOCALIZE->getPhrase('login_error_title', $lang));
		}*/
		
		/*$getdata = $this->DB->query("SELECT user_count, max_users FROM rooms WHERE id = '$room_id';");
		$section = $this->DB->fetch_array($getdata);
		if ($section['user_count'] >= $section['max_users']) {
			return array('valid' => false, 
						 'error' => $this->LOCALIZE->getPhrase('login_error_room_max_users', $lang),
						 'title' => $this->LOCALIZE->getPhrase('login_error_title', $lang));
		}*/
		
		switch ($gender) {
			case "m":
				$avatar = "upload/m_avatar.jpg";
				break;
			case "f":
				$avatar = "upload/f_avatar.jpg";
				break;
		}
		
		return array('valid' => true, 'avatar' => $avatar, 'time' => time(), 'ip' => $_SERVER['REMOTE_ADDR']);
		
	}
	
	function adminLogin($email, $pass, $lang) {
		
		$lang = $this->LOCALIZE->checkLanguage($lang);
				
		$getdata = $this->DB->query("SELECT * FROM users 
		                             WHERE email = '$email' AND password = MD5('$pass') 
									 AND (utype = 'admin' OR utype = 'demo') LIMIT 1;");
		$rows = $this->DB->get_num_rows($getdata);
		
		if ($rows == 0) {
			return array('valid' => false, 
						 'error' => $this->LOCALIZE->getPhrase('login_error_name_or_password', $lang),
						 'title' => $this->LOCALIZE->getPhrase('login_error_title', $lang));
		}
		
		$section = $this->DB->fetch_array($getdata);	
		
		$data = unserialize($section['data']);		
		$gender = $data['gender'];
		
		return array('id' => $section['id'], 
		             'utype' => $section['utype'],
		             'name' => $section['name'], 					
					 'gender' => $gender, 
					 'avatar' => $section['avatar'], 
					 'time' => time(), 
					 'valid' => true);
		
	}
	
}

?>