<?php

include_once (MYSQL);
include_once (dirname(__FILE__)."/localization.php");

class avatars {

    function avatars () {     
		$this->DB = new DB;
		$this->DB->connect();
		$this->LOCALIZE = new localization;
		define("AVATARS", IMAGES."avatars/");
		define("GALLERY", IMAGES."avatars/gallery/");
		define("AVATARS_TEMP", IMAGES."temp/");
    }
		
	function getCategories() {
		$getdata = $this->DB->query("SELECT * FROM avatars ORDER BY name ASC; ");
		while($section = $this->DB->fetch_array($getdata)) {
			$folders[] = array('name' => $section['name'], 'path' => $section['path']);
		}
		return $folders;
    }
	
	function addCategory($path, $name) {
		
		$name = addslashes($name);
		
		$getdata = $this->DB->query("SELECT * FROM avatars WHERE path = '$path' OR name = '$name';");
		$rows = $this->DB->get_num_rows($getdata);
		if ($rows > 0) return false; 
		
		$this->DB->query("INSERT INTO avatars (name, path) VALUES('$name', '$path');");
		mkdir(GALLERY.$path, 0777);
		return true;
	}
	
	function editCategory($path, $name) {
		$this->DB->query("UPDATE avatars SET name = '$name' WHERE path = '$path' LIMIT 1;");
		return true;
	}
	
	function removeCategory($path) {
		$dir = GALLERY.$path;
		if ($this->deleteFolder($dir)) {
			$this->DB->query("DELETE FROM avatars WHERE path = '$path' LIMIT 1;");
			return true;
		} else {
			return false;
		}
	}
	
	private function deleteFolder($dir) {
		if (substr($dir, strlen($dir)-1, 1) != '/') $dir .= '/';
	   	if ($handle = opendir($dir)) {
			while ($obj = readdir($handle)) {
			   if ($obj != '.' && $obj != '..') {
				   if (is_dir($dir.$obj)) {
					   if (!$this->deleteFolder($dir.$obj)) return false;
				   } elseif (is_file($dir.$obj)) {
					   if (!unlink($dir.$obj)) return false;
				   }
			   }
		   }
		   closedir($handle);
		   if (!@rmdir($dir)) return false;
		   return true;
	   }
	   return false;
	}
	
	function getImages($category) {
		
		$folders = array();
		
		$dir    = GALLERY.$category;
		$files  = scandir($dir);
		
		$types = array('gif', 'jpg', 'png', 'swf', 'psd', 'bmp', 'tiff', 'tiff', 'jpc', 'jp2', 'jpx', 'jb2', 'swc', 'iff', 'wbmp', 'xbm');
		
		for ($i=0; $i<count($files); $i++) {
			$cur_file = $dir.'/'.$files[$i];
			if (is_file($cur_file)) {
				
				list($width, $height, $type, $attr) = getimagesize($cur_file);
				$cur_type = $types[$type-1];
				
				if ($cur_type == 'gif'|| $cur_type == 'jpg' || $cur_type == 'png' || $cur_type == 'swf') {
					$images[] = 'gallery/'.$category.'/'.$files[$i];
				}
	
			}
		}
		if ($images) sort($images);
		return $images;
		
    }
	
	function setAvatarFromGallery($id, $path) {
		$source = AVATARS.$path;
		$file = $id."_".time().".jpg";
		$dest =  AVATARS."upload/".$file;
		$this->DB->query("UPDATE users SET avatar = 'upload/".$file."' WHERE id = '$id' LIMIT 1;");
		copy($source, $dest);
		return $path;
	}
	
	function removeAvatar($id) {
		$getdata = $this->DB->query("SELECT avatar FROM users WHERE id =  '$id' LIMIT 1");
		$section = $this->DB->fetch_array($getdata);
		$path = $section['avatar'];
		$file = GALLERY.$path;
		if (is_file($file)) unlink($file);
		$this->DB->query("UPDATE users SET avatar = '' WHERE id = '$id' LIMIT 1;");
		return true;
	}
	
	function addAvatar($params) {
		
		$category     = $params['category'];
		$file         = $params['file'];
		$new_width    = $params['width'];
		$new_height   = $params['height'];
		$new_x        = $params['x'];
		$new_y        = $params['y'];
		$brightness   = $params['brightness'];
		$contrast     = $params['contrast'];
		$type         = $params['type'];  
		
		if ($type == ".jpg") {
			$src_im = imagecreatefromjpeg(AVATARS_TEMP.$file);
		} else if ($type == ".jpeg") {
			$src_im = imagecreatefromjpeg(AVATARS_TEMP.$file);
		} else if ($type == ".png") {
			$src_im = imagecreatefrompng(AVATARS_TEMP.$file);
		} else if ($type == ".gif") {
			$src_im = imagecreatefromgif(AVATARS_TEMP.$file);
		}
		
		$new_filename = time().".jpg";
						
		if (function_exists('imagecreatetruecolor')) {
			$dst_im = imagecreatetruecolor($new_width, $new_height);
			imagecopyresampled($dst_im, $src_im, 0, 0, $new_x, $new_y, $new_width, $new_height, $new_width, $new_height);
		} else {
			$dst_im = imagecreate($new_width, $new_height);
			imagecopyresized($dst_im, $src_im, 0, 0, $new_x, $new_y, $new_width, $new_height, $new_width, $new_height);
		}
		
		$emboss = array(array($contrast, 0.0, 0.0), array(0.0, 0.0, 0.0), array(0.0, 0.0, 0.0));
		imageconvolution($dst_im, $emboss, 1, $brightness);
		
		imagejpeg($dst_im, GALLERY.$category."/".$new_filename, 90);
			
		unlink(AVATARS_TEMP.$file);
		
		imagedestroy($src_im);
		imagedestroy($dst_im);
		
		return true;
		
	}
	
	function removeAvatars($avatars) {
		for ($i=0; $i<count($avatars); $i++) {
			$file = AVATARS.$avatars[$i];
			if (is_file($file)) unlink($file);
		}
		return true;
	}
	
	function getImageProps($path) {
		
		$result = array();
		
		$types = array('gif', 'jpg', 'png', 'swf', 'psd', 'bmp', 'tiff', 'tiff', 'jpc', 'jp2', 'jpx', 'jb2', 'swc', 'iff', 'wbmp', 'xbm');
		
		list($width, $height, $type, $attr) = getimagesize(IMAGES.$path);
		
		$result['width']   = $width;
		$result['height']  = $height;
		$result['type']    = $types[$type-1];
		
		return $result;
		
	}
	
	function deleteImage($path) {
		$file = IMAGES.$path;
		if (is_file($file)) unlink($file);
	}
	
	function saveImage($id, $file, $b64String) {
		
		$new_filename = $id."_".time().".jpg";
		$im = imagecreatefromstring(base64_decode($b64String));
		imagejpeg($im, AVATARS."upload/".$new_filename, 90);
			
		if (is_file(AVATARS_TEMP.$file)) unlink(AVATARS_TEMP.$file);
		
		$new_path = "upload/".$new_filename;
		$this->DB->query("UPDATE users SET avatar = '$new_path' WHERE id = '$id' LIMIT 1;");
		
		return $new_path;
		
	}
	
}
?>