<?php

include_once (dirname(__FILE__)."/config.php");

class DB {

	var $server       = DB_HOST;
	var $database     = DB_NAME;
  	var $user         = DB_USER;
  	var $password     = DB_PASSWORD;
	
  	var $conn         = 0;
  	var $queryid      = 0;
  	var $row          = array();

  	var $errdesc      = "";
  	var $errno        = 0;

  	var $query_count  = 0;

  	// ###################### connect #######################
  	function connect() {
		if(0 == $this->conn) {
			if($this->password=="") {
				$this->conn = mysql_connect($this->server,$this->user);
			} else {
				$this->conn = mysql_connect($this->server,$this->user,$this->password);
			}
			if(!$this->conn) {
				$this->error("Connection == false, connect failed");
			}
			if($this->database != "") {
				if(!mysql_select_db($this->database, $this->conn)) {
					$this->error("cannot use database ".$this->database);
				}
			}
		}
		$this->query("SET NAMES 'utf8';");
  	}

  	// ###################### select database #######################
  	function select_db($database = "") {
    	if($database != "") {
      		$this->database = $database;
    	}
    	if(!mysql_select_db($this->database, $this->conn)) {
     		$this->error("cannot use database ".$this->database);
    	}
  	}

  	// ##################### format database query ######################
  	function _format_query_callback($match, $init = FALSE) {
    	static $args = NULL;
    	if ($init) {
      		$args = $match;
      		return;
    	}
    	switch ($match[1]) {
      		case '%d':
        		return (int) array_shift($args);
      		case '%s':
        		/* Could do mysql_real_escape_string here but it's already been done in SD */
        		return array_shift($args);
      		case '%%':
        		return '%';
      		case '%f':
        		return (float) array_shift($args);
      		case '%b': // binary data
      			return db_encode_blob(array_shift($args));
    	}
  	}

  	function _format_query($sql, $args) {
    	if (isset($args[0]) and is_array($args[0])) {
      		$args = $args[0];
    	}
    	$this->_format_query_callback($args, TRUE);
    	$sql = preg_replace_callback('/(%d|%s|%%|%f|%b)/', array($this, '_format_query_callback'), $sql);
    	return $sql;
  	}
   		
  	// ###################### query #######################
  	function query($query_string) {
    	$args = func_get_args();
    	array_shift($args);
	  	//$query_string = preg_replace("/\{([^}]\S+)}/", "$1", $query_string);
	  	$query_string = str_replace("pagebreak", "{pagebreak}", $query_string);
    	if(count($args) > 0) {
      		$query_string = $this->_format_query($query_string, $args);
    	}
    	$this->queryid = mysql_query($query_string, $this->conn);
    	if (!$this->queryid) {
		  $this->error("Invalid SQL: " . $query_string);
    	}
    	$this->query_count++;
    	return $this->queryid;
  	}

  	// ###################### query first #######################
  	function query_first($query_string) {
    	$args = func_get_args();
    	array_shift($args);
    	$queryid      = $this->query($query_string, $args);
    	$returnarray  = $this->fetch_array($queryid, $query_string);
    	$this->free_result($queryid);
    	return $returnarray;
  	}

  	// ###################### fetch array #######################
  	function fetch_array($queryid=-1,$query_string="") {
    	if($queryid != -1) {
      		$this->queryid=$queryid;
    	}
    	if(isset($this->queryid)) {
      		if(($this->row = mysql_fetch_array($this->queryid)) === FALSE) {
        		return null;
      		}
    	} else {
      		if(!empty($query_string)) {
				$this->error("Invalid query id (".$this->queryid.") on query string: $query_string");
			} else {
				$this->error("Invalid query id: ".$this->queryid);
			}
    	}
    	return $this->row;
  	}

  	// ###################### fetch array #######################
  	function affected_rows() {
		if($this->conn) {
		  	$result = @mysql_affected_rows($this->conn);
		  	return $result;
		} else {
		  	return false;
		}
  	}

  	// ###################### free result #######################
  	function free_result($queryid=-1) {
    	if($queryid != -1) {
      		$this->queryid = $queryid;
    	}
    	return @mysql_free_result($this->queryid);
  	}

  	// ###################### number of rows #######################
  	function get_num_rows() {
    	return mysql_num_rows($this->queryid);
  	}


  	// ###################### number of fields #######################
  	function get_num_fields() {
    	return mysql_num_fields($this->queryid);
  	}


  	// ############ return last auto_increment number ##############
  	function insert_id() {
    	return mysql_insert_id($this->conn);
  	}

  	// ###################### close the connection to the database #######################
  	function close() {
    	return mysql_close($this->conn);
  	}

  	// ###################### get error description #######################
  	function geterrdesc() {
    	$this->error = mysql_error();
    	return $this->error;
  	}

  	// ###################### get error number #######################
  	function geterrno() {
    	$this->errno = mysql_errno();
    	return $this->errno;
  	}

	// ###################### error message #######################
  	function error($msg) {
    	return array('id' => mysql_error(), 'message' => mysql_errno());
  	}
	
	// ###################### populate database #######################
	function populateDatabase($sqlfile) {
		if(!($buffer = file_get_contents($sqlfile))) {
			return false;
		}
		$queries = $this->_splitSql($buffer);
		foreach ($queries as $query) {
			$query = trim($query);
			if ($query != '' && $query{0} != '#') {
				$this->query($query);
			}
		}
	}
	
	function _splitSql($sql)	{
		$sql = trim($sql);
		$sql = preg_replace("/\n\#[^\n]*/", '', "\n".$sql);
		$buffer = array();
		$ret = array();
		$in_string = false;
		for ($i = 0; $i < strlen($sql) - 1; $i ++) {
			if ($sql[$i] == ";" && !$in_string)	{
				$ret[] = substr($sql, 0, $i);
				$sql = substr($sql, $i +1);
				$i = 0;
			}
			if ($in_string && ($sql[$i] == $in_string) && $buffer[1] != "\\") {
				$in_string = false;
			} elseif (!$in_string && ($sql[$i] == '"' || $sql[$i] == "'") && (!isset ($buffer[0]) || $buffer[0] != "\\")) {
				$in_string = $sql[$i];
			}
			if (isset ($buffer[1])) {
				$buffer[0] = $buffer[1];
			}
			$buffer[1] = $sql[$i];
		}
		if (!empty ($sql)) {
			$ret[] = $sql;
		}
		return $ret;
	}

}

?>